XXD(1)

NAZWA
xxd - zrzut pliku do hex lub odwrotnie

SYNOPSIS
xxd -h[elp]
xxd [opcje] [plik_we [plik_wy]]
xxd -r[evert] [opcje] [plik_we [plik_wy]]

OPIS
xxd tworzy zrzut heksowy podanego pliku lub standardowego wej�cia. Mo�e tak�e przetworzy� zrzut heksowy z powrotem do oryginalnej, binarnej formy. Podobnie jak uuencode(1) i uudecode(1) pozwala na przekazanie danych binarnych w bezpiecznej w poczcie formie ASCII, ale ma zalety dekodowania na standardowe wyj�cie. Ponadto mo�na go u�y� do binarnego �atania plik�w.

OPCJE
Je�li nie podano plik_we xxd czyta ze standardowego wej�cia. Je�li okre�lono plik_we jako znak `-' wtedy dane wej�ciowe czytane s� ze standardowego wej�cia. Je�li nie podano plik_wy (lub podano jako `-' ), wyniki s� wysy�ane na standardowe wyj�cie.

Pami�taj, �e u�yty zosta� "leniwy" parser, kt�ry nie sprawdza wi�cej ni� pierwszej litery opcji (o ile ta nie zosta�a obdarzona parametrem). Spacje mi�dzy jedno literowymi opcjami i ich parametrami s� opcjonalne. Parametry opcji mog� by� okre�lone w notacji dziesi�tnej, heksadecymalej lub oktalnej. St�d -c8, -c 8, -c 010 i -cols 8 s� sobie r�wnowa�ne.

-a | -autoskip
    prze��cza autoskip: pojedyncza '*' zast�puje linie nul. Domy�lnie wy��czone.

-b | -bits
    Prze��cza do zrzutu bitowego (cyfr binarnych) zamiast heksowego. Opcja ta zapisuje oktety jako osiem cyfr 1 lub 0 zamiast normalnego zrzutu heksowego. Ka�da linia jest poprzedzona przez heksadecymalny numer linii a po nim jego reprezentacj� w ascii (lub ebcdic). Opcje linii polece� -p, -i nie dzia�aj� w tym trybie.

-c cols | -cols cols
    formatuje liczb� <cols> oktet�w na wiersz. Domy�lnie 16 (-i: 12, -ps: 30, -b: 6). Maks. 256.

-E | -EBCDIC
    zmienia kodowanie znak�w w prawej kolumnie z ASCII na EBCDIC. Nie zmienia prezentacji heksadecymalej. Opcja nie dzia�a w po��czeniu z -r, -p lub -i.

-g bajt�w | -groupsize bajt�w
    oddziela wyj�cie ka�dych <bajt�w> bajt�w (dwa heksowe znaki lub osiem cyfr binarnych ka�de) przez bia�y znak. Okre�l -g 0 by wy��czy� grupowanie. <Bajt�w> domy�lnie jest 2 w trybie normalnym i 1 w trybie bit�w. Grupowanie nie dzia�a w trybie postscriptu lub w��czania.

-h | -help
    wypisuje podsumowanie dost�pnych polece� i ko�czy dzia�anie. Nie zostaje przeprowadzony �aden zrzut.

-i | -include
    wyj�cie w stylu w��czania pliku w C. Zostaje zapisana kompletna statyczna tablica definicji (nazwana wed�ug pliku wej�cia), o ile xxd nie czyta ze standardowego wej�cia.

-l len |-len len
    zako�cz po wypisaniu <len> oktet�w.

-p | -ps | -postscript | -plain
    wyj�cie w postcriptowym ci�g�ym stylu zrzutu heksowego. Znany tak�e jako zwyk�y zrzut heksowy.

-r | -revert
    odwr�� operacj�: przekonwertuj (lub za�ataj) zrzut heksowy w binark�. Je�li nie zapisuje na standardowe wyj�cie, xxd zapisze plik wyj�ciowy bez obcinania go. U�yj kombinacji -r -p by odczyta� zwyk�y zrzut heksadecymalny bez numer�w linii i okre�lonego uk�adu kolumn. Dodatkowe bia�e znaki i �amanie wierszy s� wsz�dzie dozwolone.

-seek offset
    Kiedy u�yty po -r: odwraca z <offset> dodanym do pozycji w pliku odnalezionym w zrzucie heksowym.

-s [+][-]seek
    zaczyna na <seek> bajt�w bezwgl�dnego (lub wzgl�dnego) offsetu pliku wej�ciowego. + wskazuje, �e seek jest wzgl�dne do bie��cej pozycji pliku (bez znaczenia je�li nie wczytuje ze standardowego wej�cia). - wskazuje �e seek powinno by� o tyle znak�w od ko�ca wej�cia (lub je�li po��czone z +: przed bie��c� pozycj� pliku na standardowym wej�ciu). Bez opcji -s xxd zaczyna od bie��cej pozycji w pliku.

-u  u�yj wielkich liter w znakach heksowych. Domy�lnie s� ma�e znaki.

-v | -version
    pokazuje wersj� programu.

OSTRZE�ENIA

xxd -r potrafi okre�li� numery linii. Je�li plik wyj�cia jest mo�liwy do przeszukania wtedy numery linii na pocz�tku wiersza zrzutu heksowego mog� by� nie po kolei, mo�e brakowa� wierszy lub nak�ada� si� na siebie. W takich wypadkach xxd u�yje lseek(2) by znale�� nast�pn� pozycj�. Je�li plik wyj�ciowy nie jest mo�liwy do przeszukania mo�liwe s� tylko przerwy, kt�re zostan� wype�nione bajtami null.

xxd -r nigdy nie podaje b��d�w analizy. �mieci s� po cichu ignorowane.

W czasie edycji zrzut�w heksowych, prosz� zauwa�y� �e xxd -r pomija wszystko w linii wej�cia po odczytaniu wystarczaj�cej ilo�ci kolumn danych heksadecymalnych (zobacz opcj� -c). Oznacza to tak�e, �e zmiany w drukowanych kolumnach ascii (lub ebcdic) s� zawsze ignorowane. Odwr�cenie zwyk�ego (lub postscriptowego) stylu zrzutu poprzez xxd -r -p nie zale�y od kolejno�ci kolumn. Tutaj cokolwiek co wygl�da jak para znak�w heks jest interpretowane.

Zauwa� r�nic� mi�dzy
% xxd -i plik
i
% xxd -i < plik

xxd -s +seek mo�e by� r�ne od xxd -s seek, poniewa� lseek(2) jest u�yty do "przewini�cie" wej�cia. '+' stanowi r�nic� je�li �r�d�em wej�cia jest standardowe wej�cie i je�li pozycja w pliku ze standardowego wej�cia nie jest pocz�tkiem pliku w chwili uruchomienia xxd. Nast�puj�ce przyk�ady mog� wyja�ni� (lub bardziej zmyli�!)...

Przewi� standardowe wej�cie przed przeczytaniem; potrzebne poniewa� `cat' ju� odczyta� do ko�ca standardowego wej�cia.
% sh -c 'cat > zwyk�a_kopia; xxd -s 0 > hex_kopia' < plik

Zrzut heksowy od pozycji pliku 0x480 (=1024+128) w prz�d. Znak `+' oznacza "wzgl�dny wobec bie��cej pozycji", st�d `128' dodaje do 1k gdzie zako�czy� dd.
% sh -c 'dd of=plain_snippet bs=1k count=1; xxd -s +128 > hex_snippet' < file

Zrzut heksowy od pozycji pliku 0x100 ( = 1024-768) dalej.
% sh -c 'dd of=plain_snippet bs=1k count=1; xxd -s +-768 > hex_snippet' < file

Jakkolwiek, jest to rzadka sytuacja i u�ycie `+' jest rzadko potrzebne. Autor woli monitorowa� dzia�anie xxd przy pomocy strace(1) lub truss(1) kiedy -s jest u�yte.

PRZYK�ADY

Wypisz wszystko z wyj�tkiem pierwszych trzech linii (heksowe 0x30 bajt�w) pliku .
% xxd -s 0x30 plik

Wypisz trzy linie (heksowe 0x30 bajt�w) z ko�ca pliku .
% xxd -s -0x30 plik

Wypisz 120 bajt�w jako ci�g�y zrzut heksowy z 20 oktetami na lini�.
% xxd -l 120 -ps -c 20 xxd.1
2e54482058584420312022417567757374203139
39362220224d616e75616c207061676520666f72
20787864220a2e5c220a2e5c222032317374204d
617920313939360a2e5c22204d616e2070616765
20617574686f723a0a2e5c2220202020546f6e79
204e7567656e74203c746f6e79407363746e7567
Zrzut heksowy z pierwszymi 120 bajtami tej strony podr�cznika z 12 oktetami na lini�.
% xxd -l 120 -c 12 xxd.1
0000000: 2e54 4820 5858 4420 3120 2241 .TH XXD 1 "A
000000c: 7567 7573 7420 3139 3936 2220 ugust 1996"
0000018: 224d 616e 7561 6c20 7061 6765 "Manual page
0000024: 2066 6f72 2078 7864 220a 2e5c for xxd"..\
0000030: 220a 2e5c 2220 3231 7374 204d "..\" 21st M
000003c: 6179 2031 3939 360a 2e5c 2220 ay 1996..\"
0000048: 4d61 6e20 7061 6765 2061 7574 Man page aut
0000054: 686f 723a 0a2e 5c22 2020 2020 hor:..\"
0000060: 546f 6e79 204e 7567 656e 7420 Tony Nugent
000006c: 3c74 6f6e 7940 7363 746e 7567 <tony@sctnug

Poka� tylko dat� z pliku xxd.1
% xxd -s 0x36 -l 13 -c 13 xxd.1
0000036: 3231 7374 204d 6179 2031 3939 36 21st May 1996

Kopiuj plik_we do plik_wy i poprzed� 100 bajtami o warto�ci 0x00.
% xxd plik_we | xxd -r -s 100 > plik_wy
Podmie� dat� w pliku xxd.1
% echo '0000037: 3574 68' | xxd -r - xxd.1
% xxd -s 0x36 -l 13 -c 13 xxd.1
0000036: 3235 7468 204d 6179 2031 3939 36 25th May 1996

Utw�rz plik o 65537 bajtach, wszystkich r�wnych 0x00, z wyj�tkiem ostatniego, kt�ry ma by� 'A' (hex 0x41).
% echo '010000: 41' | xxd -r > plik

Zrzut heksowy tego pliku z autoskipem.
% xxd -a -c 12 plik
0000000: 0000 0000 0000 0000 0000 0000 ............
*
000fffc: 0000 0000 40 ....A

Utw�rz jedno bajtowy plik zawieraj�cy pojedncz� liter� 'A'. Liczba po '-r -s' dodaje numery linii znalezione w pliku; w efekcie poprzedzaj�ce bajty s� ukryte.
% echo '010000: 41' | xxd -r -s -0x10000 > plik

U�yj xxd jako filtra wewn�trz edytora takiego jak mnv(1) aby uzyska� zrzut heksowy zakresu mi�dzy markerami `a' i `z'.
:'a,'z!xxd

U�yj xxd jako filtra wewn�trz edytora takiego jak mnv(1) by odzyska� binarny zrzut heksowy zakresu pomi�dzy markerami `a' i `z'.
:'a,'z!xxd -r

U�yj xxd jako filtra wewn�trz edytora takiego jak mnv(1) by odzyska� jedn� lini� zrzutu heksowego. Przejd� z kursorem na lini� i wpisz:
!!xxd -r

Odczytaj pojednycze znaki z portu szeregowego
% xxd -c1 < /dev/term/b &
% stty < /dev/term/b -echo -opost -isig -icanon min 1
% echo -n foo > /dev/term/b

ZWRACANE WARTO�CI
Zwracane s� nast�puj�ce warto�ci b��d�w:

0   nie znaleziono b��d�w.

-1  operacja nie jest wspierana ( xxd -r -i ca�y czas niemo�liwa).

1   b��d w czasie analizowania opcji.

2   problemy z plikiem wej�ciowym.

3   problemy z plikiem wyj�ciowym.

4,5 ��dana pozycja jest nieosi�galna.

ZOBACZ TAK�E
uuencode(1), uudecode(1), patch(1)

OSTRZE�ENIA
Dziwaczno�� narz�dzi dor�wnuje dziwaczno�ci m�zgu tw�rcy. U�ywaj wy��cznie na w�asn� odpowiedzialno��. Kopiuj pliki. Analizuj je. Sta� si� czarodziejem.

WERSJA
Strona podr�cznika opisuje xxd w wersji 1.7

AUTOR
(c) 1990-1997 by Juergen Weigert
<jnweiger@informatik.uni-erlangen.de>

Kopiuj do woli i podaj moje dane,
zarabiaj pieni�dze i dziel si� ze mn�,
tra� pieni�dze i nie miej do mnie pretensji.

Strona podr�cznika zapocz�tkowana przez Tony'ego Nugenta
<tony@sctnugen.ppp.gu.edu.au> <T.Nugent@sct.gu.edu.au>
Ma�e zmiany: Bram Moolenaar. Redakcja: Juergen Weigert.